**************************************
// author Brunello Pulix
// Cagliari (Italy)
// brunellopulix@gmail.com
// placed in the Private domain
**************************************
//
# include "hmg.ch"
# include "..\HmgP2PServer.ch"
*
# include "..\fileio.prg"
# include "..\Tools.prg"
*
#translate NTRIM( <v1> ) => Ltrim(str(<v1>))
*
Request DbfCdx
*
FUNCTION MAIN()
  Local lTurnOff   := .T.
  Local lFlag      := .F.
  *
  Set BrowseSync On
  RDDSetDefault('DBFCDX')
  *
  IF FILE('HMGP2PClient.ZIP')
     execute File ('Run_App.exe') parameters 'HMGP2PClient'
     Return
  Endif
  *
  IF FILE('_HMGP2PClient.EXE')
     Ferase('_HMGP2PCLIENT.EXE')
     MsgInfo('OK! Update done!')
  Endif
  *
  IF !File('CFG.INI')
     Ini_Open('CFG.INI')
     Ini_Put("Setup","Host"     ,"Localhost")
     Ini_Put("Setup","IP"       ,"127.0.0.1")
     Ini_Put("Setup","User"     ,"LocalHost")
     Ini_Put("Setup","LocalHost",'127.0.0.1')
     Ini_Close()
  Endif
  *
  Private cIP
  Private cHost
  Private cUser
  Private lStop
  Private lDownload
  Private aListFiles
  Private cLocalHost
  *
  Ini_Open('CFG.Ini')
  cIP        := Ini_Get("Setup","IP"  )
  cHost      := Ini_Get("Setup","Host")
  cUser      := Ini_Get("Setup","User")
  cLocalHost := Ini_Get("Setup","LocalHost")
  Ini_Close()
  *
  lStop      := .F.
  lDownload  := .T.
  aListFiles := {}
  *
  IF File(__CODEENABLETURNOFF__)
     lTurnOff := .F.
  Endif
  *
  IF File('Run_App.Exe')
     lFlag := .T.
  Endif
  *
  Install()
  *
  FV3_OpenMain([HMGP2PClient with Netio -  - by Brunello Pulix (Italy)],nil,{|cWinMain| PostInit(cWinMain) },{|| dbcloseall() })
  FV3_SetValue('TEXT1','..........CLIENT DISCONNECT.........')
  FV3_SetValue('TEXT3','')
  FV3_SetValue('TEXT4','Host: '+cHost+'    Address: '+cIP+'    User: '+cUser)
  FV3_SetValue('TEXT5','List files on the server')
  FV3_SetValue('TEXT6','waiting to download')
  FV3_SetValue('RGROUP1',1)
  FV3_SetValue('RGROUP2',1)
  FV3_SetValue('LSTBOX1','')
  FV3_SetValue('LSTBOX2','')
  *
  FV3_FramedText3('TEXT4',700,1,CLR_BROWN,'Arial',13,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_FramedText3('TEXT1',700,1,CLR_RED,'Arial',13,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ProgressBar('PBar1',698,20)
  FV3_SkipRow(20)
  FV3_FramedText3('TEXT3',700,1,CLR_WHITE,'Arial',9,,.T.,.T.,.T.,.F.,.F.)
  *
  FV3_SkipRow(30)
  *
  FV3_Button(_UPLOAD_B_       , 70,30,{|cWinMain| UploadServer(cWinMain,'B')      },.T.  )
  FV3_Button(_UPLOAD_C_       , 70,30,{|cWinMain| UploadServer(cWinMain,'C')      },.T.  )
  FV3_Button(_UPDATE_CLIENT_  ,100,30,{|cWinMain| UpdateClient('HMGP2PCLIENT')    },lFlag)
  FV3_Button(_FOLDER_UPLOAD_  ,100,30,{|cWinMain| OpenFolder(1)                   },.T.  )
  FV3_Button(_FOLDER_DOWNLOAD_,115,30,{|cWinMain| OpenFolder(2)                   },.T.  )
  FV3_Button(_PAUSE_          , 80,30,{|cWinMain| lStop := .T.                    },.F.  )
  FV3_Button(_IP_             , 80,30,{|cWinMain| Mask2(cWinMain)                 },.T.  )
  FV3_ButtonCancel(_CLOSE_    , 85,30)
  *
  FV3_SkipRow(30)
  *
  FV3_FramedText3('TEXT5',700,1,CLR_BROWN,'Arial',13,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ListBox('LSTBOX1',700,200,{''},,{|cWinMain| SetLstBox1(cWinMain) })
  FV3_SkipRow(10)
  #Ifdef ___FV3_HMG___
  FV3_RadioGroup('RGROUP2',300,{'Stop Download','Start Download'},.T.,150,{.F.,.F.})
  #else
  FV3_RadioGroup('RGROUP2',150,{'Stop Download','Start Download'},.T.,30,{.F.,.F.})
  #endif
  FV3_SkipRow(10)
  FV3_FramedText3('TEXT6',700,1,CLR_BROWN,'Arial',13,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ListBox('LSTBOX2',700,100,{''},,{|cWinMain| SetLstBox2(cWinMain) })
  *
  FV3_SkipRow(10)
  FV3_Label('What to do when the downloads / uploads have been completed:',700)
  FV3_SkipRow(15)
  *
  #Ifdef ___FV3_HMG___
  FV3_RadioGroup('RGROUP1',700,{'nothing','Close Client','Close Client e Server'},.T.,150,{.F.,.F.,lTurnOff})
  #else
  FV3_RadioGroup('RGROUP1',150,{'nothing','Close Client','Close Client e Server'},.T.,30,{.F.,.F.,lTurnOff})
  #endif
  *
  FV3_SetFont('TEXT1','Courier New',9)
  FV3_SetFont('LSTBOX1','Courier New',9)
  FV3_SetFont('LSTBOX2','Courier New',9)
  *
  FV3_Show(0)
  *
Return
*
Procedure PostInit(cWinMain)
  Local i,c1
  *
  IF NETIO_CONNECT(cIP,2941)
     *
     Use "net:"+cIP+":2941:DB\Log" Shared New
     Use "net:"+cIP+":2941:DB\IdxServerA" Shared New
     Use "net:"+cIP+":2941:DB\IdxServerB" Shared New
     Use "net:"+cIP+":2941:DB\IdxServerC" Shared New
     *
     For i := 1 To 10
        c1 := ntrim(i)
        Use "net:"+cIP+":2941:DB\ServerA"+c1 Shared New
        Use "net:"+cIP+":2941:DB\ServerB"+c1 Shared New
        Use "net:"+cIP+":2941:DB\ServerC"+c1 Shared New
     Next
     *
     FillLstBox1(cWinMain)
  else
     FV3_DisableButton(_UPLOAD_B_        )
     FV3_DisableButton(_UPLOAD_C_        )
     FV3_DisableButton(_FOLDER_UPLOAD_   )
     FV3_DisableButton(_FOLDER_DOWNLOAD_ )
     FV3_DisableButton(_UPDATE_CLIENT_   )
  Endif
  *
Return
*
Procedure Install()
  Local i
  Local aDbf
  *
  MakeDir([LOCAL])
  MakeDir([UPLOAD])
  MakeDir([DOWNLOAD])
  MakeDir([DB])
  *
  IF !File('DB\IP.DBF')
     *
     aDbf := {;
     {'HOST'     ,'C', 30,  0},;
     {'ADDRESS'  ,'C', 15,  0},;
     {'USER'     ,'C', 30,  0},;
     {'LOCALHOST','C', 15,  0}}
     DBCREATE('DB\IP.DBF',aDbf,'DBFCDX')
     *
     Use 'DB\IP' New
     For i := 1 To 10
        dbappend()
        Replace HOST      with 'LocalHost'
        Replace ADDRESS   with '127.0.0.1'
        Replace USER      with 'User'+ntrim(i)
        Replace LOCALHOST with '127.0.0.1'
     Next
     dbclosearea('IP')
  ENDIF
  *
  *
Return
*
Procedure UpdateClient(cCode)
  Local c1
  Local c2
  *
  FV3_DisableButton(_UPDATE_CLIENT_)
  *IF NETIO_CONNECT(cIP,2941)
  *
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_YELLOW)
  Use "net:"+cIP+":2941:DB\Server" New
  Server->(dbgotop())
  If Server->(Eof())
     MsgInfo('Error! No Update Found')
     dbclosearea('Server')
     FV3_EnableButton(_UPDATE_CLIENT_)
     Return
  Endif
  *
  Server->(__dbLocate({|| Trim(Server->Prog) == cCode+'.ZIP'}))
  If Found()
     *
     c1 := Trim(Server->Pass)
     c2 := UnoGet('Password For Update',space(25),'password?','',300,3)
     If Trim(c2) != c1 .or. empty(c2)
        msginfo('Error! Access denied!')
        dbclosearea('Server')
        FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
        FV3_SetProperty('TEXT1','Value','..........CLIENT DISCONNECT..........')
        FV3_EnableButton(_UPDATE_CLIENT_  )
        Return
     Endif
     *
     FV3_SetProperty('TEXT1','Value','.........wait..........')
     hb_MemoWrit(Server->Prog,hb_Base64Decode(Server->Note))
     If File(Trim(Server->Prog))
        MsgInfo('successful operation!')
     Endif
  else
     MsgInfo('operation failed!')
  Endif
  dbclosearea('Server')
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
  FV3_SetProperty('TEXT1','Value','..........CLIENT DISCONNECT..........')
  *
  If File(cCode+'.ZIP')
     execute file ('Run_App.exe') parameters cCode
     FV3_EndWindow()
  Endif
  *Else
  *  MsgInfo('connection error!')
  *Endif
  FV3_EnableButton(_UPDATE_CLIENT_  )
  PBar1(0)
  *
Return
*
Procedure OpenFolder(n)
  *
  If n == 1
     execute file 'UPLOAD'
  else
     execute file 'DOWNLOAD'
  Endif
  *
Return
*
Procedure DisableAll()
  *
  FV3_DisableButton(_UPLOAD_B_        )
  FV3_DisableButton(_UPLOAD_C_        )
  FV3_DisableButton(_FOLDER_UPLOAD_   )
  FV3_DisableButton(_FOLDER_DOWNLOAD_ )
  FV3_DisableButton(_CLOSE_           )
  FV3_DisableButton(_UPDATE_CLIENT_   )
  *
Return
*
Procedure EnableAll()
  *
  FV3_EnableButton(_UPLOAD_B_       )
  FV3_EnableButton(_UPLOAD_C_       )
  FV3_EnableButton(_FOLDER_UPLOAD_  )
  FV3_EnableButton(_FOLDER_DOWNLOAD_)
  FV3_EnableButton(_CLOSE_          )
  FV3_EnableButton(_UPDATE_CLIENT_  )
  *
Return
*
Procedure Mask2(cWinMain)
  Local aTemp := {}
  Local nChoice
  *
  Use 'DB\IP' New
  IP->(dbgotop())
  *
  FV3_OpenModal('Network Information')
  *
  FV3_Browse('BROWSE1',650,300         ,;
  {180,180,180,100}                    ,;
  {'Network','Address','User','YourIp'} ,;
  'IP'                                 ,;
  {'IP->Host','IP->Address','IP->User','IP->LocalHost'},;
  {|| Mask2Property(cWinMain) },nil  ,;
  {0,0,0,0})
  *
  FV3_SkipRow(-20)
  *
  FV3_Show(1)
  *
  If FV3_Result()
     *
  Endif
  *
  dbclosearea('IP')
  *
Return
*
Procedure Mask2Property(cWinMain)
  *
  FV3_OpenModal('Network Property')
  FV3_SetValue('HOST'     ,IP->Host)
  FV3_SetValue('ADDRESS'  ,IP->ADDRESS)
  FV3_SetValue('USER'     ,IP->USER)
  FV3_SetValue('LOCALHost',IP->LocalHost)
  FV3_SetValue('CHECK1' ,.F.)
  *
  FV3_Label('Server Name',100)
  FV3_TextBox("HOST",200,'',0)
  *
  FV3_SkipRow(30)
  FV3_Label('Server IP',100)
  FV3_TextBox("ADDRESS",200,'',0)
  *
  FV3_SkipRow(30)
  FV3_Label('Your Name'  ,100)
  FV3_TextBox("USER",200,'',0)
  *
  FV3_SkipRow(30)
  FV3_Label('Your IP'     ,100)
  FV3_TextBox("LOCALHOST",200,'',0)
  *
  FV3_SkipRow(30)
  FV3_Label('',100)
  FV3_CheckBox('CHECK1',200,'Set Default')
  *
  FV3_Show(2)
  *
  If FV3_Result()
     *
     Replace IP->Host      with FV3_GetValue('HOST')
     Replace IP->Address   with FV3_GetValue('ADDRESS')
     Replace IP->User      with FV3_GetValue('USER')
     Replace IP->LOCALHOST with FV3_GetValue('LOCALHOST')
     FV3_SetProperty('BROWSE1','Value',IP->(Recno()))
     FV3_DoMethod('BROWSE1','Refresh')
     *
     If FV3_GetValue('CHECK1')
        cHost      := Trim(IP->Host)
        cIP        := Trim(IP->Address)
        cUser      := Trim(IP->User)
        cLocalHost := Trim(IP->LocalHost)
        Ini_Open('CFG.INI')
        Ini_Put("Setup","Host",cHost)
        Ini_Put("Setup","IP"  ,cIP)
        Ini_Put("Setup","User",cUser)
        Ini_Put("Setup","LocalHost",cLocalHost)
        Ini_Close()
        SetProperty(cWinMain,'TEXT4','Value','Host: '+cHost+'    Address: '+cIP+'    User: '+cUser)
     Endif
     *
  Endif
  *
Return
*
Procedure UploadServer(cWinMain,cOpz)
  Local n1
  Local n2
  Local n3
  Local cString
  Local nBytes
  Local nBytes2
  Local nHandle
  Local c1
  Local c2
  Local c3
  Local c4
  Local c5
  Local nTotBytes
  Local aTemp
  Local cUser
  Local cPass
  Local lAbort := .F.
  Local nBox1
  Local x1,x2,x3
  Local a1  := {'25%','50%','75%'}
  *
  n1 := MyFormB(cOpz)
  If n1 == 0
     Return
  Endif
  DisableAll()
  FV3_SetProperty('RGROUP2','Enabled',.F.)
  *
  c2 := ntrim(n1)
  *
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_YELLOW)
  *
  *
  dbselectarea("IdxServer"+cOpz)
  (Alias())->(dbgoto(n1))
  *
  cUser := Trim((Alias())->User)
  cPass := Trim((Alias())->Pass)
  c1    := Trim((Alias())->Title)
  *
  c3 := UnoGet('Password For Upload',space(25),'User '+cUser+' Type password:','',300,3)
  If Trim(c3) != cPass .or. empty(c3)
     msginfo('Error! Access denied!')
     dbselectarea("IdxServer"+cOpz)
     (Alias())->(dbgoto(n1))
     If (Alias())->(Rlock())
        (Alias())->Title := ''
        (Alias())->(__dbUnlock())
     Endif
     *
     FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
     FV3_SetProperty('TEXT1','Value','..........CLIENT DISCONNECT..........')
     EnableAll()
     Return
  Endif
  *
  FV3_EnableButton(_PAUSE_)
  lStop := .F.
  *
  dbselectarea("Server"+cOpz+c2)
  dbclosearea("Server"+cOpz+c2)
  *
  Use "net:"+cIP+":2941:DB\Server"+cOpz+c2 New
  (Alias())->(__dbzap())
  close
  *
  Use "net:"+cIP+":2941:DB\Server"+cOpz+c2 Shared New
  ("Server"+cOpz+c2)->(dbgotop())
  *
  SendToLog('('+cOpz+c2+') - '+Time()+' - Upload '+c1)
  *
  FV3_SetProperty('TEXT1','Value','..........Data conversion and uploading..........')
  FV3_SetProperty('TEXT3','Value',c1)
  *
  nBytes    := 5700*8
  cString   := ''
  nHandle   := Fopen('UPLOAD\'+c1)
  cBuff     := space(nBytes)
  nTotBytes := FileSize(nHandle)
  FileTop(nHandle,0)
  *
  PBar1(0,(nTotBytes/nBytes))
  PBar1(0)
  *
  #ifdef ___FV3_HMG___
  SETPROGRESSBARMARQUEE(GetControlHandle('PBAR1',cWinMain), .T.,6000)
  #endif
  n2      := 0
  nBytes2 := 0
  *
  x2 := int((nTotBytes/nBytes)/2)
  x1 := int(x2/2)
  x3 := x2+x1
  n3 := 0
  *
  Do While ("Server"+cOpz+c2)->(!Feof(nHandle))
     PBar1(++n2)
     FV3_SetProperty('TEXT1','Value','Data conversion and uploading   ('+ntrim(nTotBytes)+')')
     *
     Fread(nHandle,@cBuff,nBytes)
     nBytes2 += nBytes
     ("Server"+cOpz+c2)->(dbappend())
     Replace ("Server"+cOpz+c2)->Title with c1
     Replace ("Server"+cOpz+c2)->Note  with hb_Base64Encode(cBuff,76)
     Replace ("Server"+cOpz+c2)->Bytes with nBytes2
     nTotBytes -= nBytes
     If nTotBytes < nBytes
        nBytes := nTotBytes
        cBuff  := space(nBytes)
     Endif
     *
     IF ("Server"+cOpz+c2)->(Recno()) == x1 .or. ("Server"+cOpz+c2)->(Recno()) == x2 .or. ("Server"+cOpz+c2)->(Recno()) == x3
        SendToLog('('+cOpz+c2+') - '+Time()+' ('+a1[++n3]+')'+'-Upload '+Trim(c1))
     Endif
     If lStop
        lStop := .F.
        If MsgYesNo('Abort Operation?')
           close
           Use "net:"+cIP+":2941:DB\Server"+cOpz+c2 New
           ("Server"+cOpz+c2)->(__dbzap())
           close
           lAbort := .T.
           exit
        endif
     Endif
     *
  Enddo
  FV3_SetProperty('TEXT1','Value','--------------Wait------------')
  FClose(nHandle)
  *
  #ifdef ___FV3_HMG___
  SETPROGRESSBARMARQUEE(GetControlHandle('PBAR1',cWinMain), .F., 0)
  #endif
  FV3_DisableButton(_PAUSE_)
  *
  FV3_SetProperty('TEXT3','Value','')
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
  FV3_SetProperty('TEXT1','Value','..........CLIENT DISCONNECT..........')
  *
  nBox1 := FV3_GetProperty('RGROUP1','Value')
  *
  If nBox1 == 1
     * nothing
     If lAbort == .T.
        c4 := '('+cOpz+c2+') - '+Time()+' - Upload Aborted!'
        c5 := 'Aborted operation!'
     else
        c4 := '('+cOpz+c2+') - '+Time()+' (100%)-Upload Completed!'
        c5 := 'Successful operation!'
     Endif
     *
     SendToLog(c4)
     *
     MsgInfo(c5)
     *
  elseIf nBox1 == 2
     FV3_EndWindow()
  elseif nBox1 == 3
     Exit_App(cWinMain)
     FV3_EndWindow()
  endif
  *
  PBar1(0)
  EnableAll()
  FV3_SetProperty('RGROUP2','Enabled',.T.)
  *
  FillLstBox1(cWinMain)
  *
Return
*
Procedure MyFormB(cOpz)
  Local  a1    := {}
  Local  a2    := {}
  Local  a3    := {}
  Local aTemp  := {}
  Local nRet   := 0
  Local i
  *
  aTemp := Directory('UPLOAD\*.*','A')
  If Empty(aTemp)
     Return 0
  Endif
  *
  For i := 1 To Len(aTemp)
     aadd(a1,aTemp[i,1])
  Next
  *
  If empty(a1)
     Return 0
  Endif
  *
  dbselectarea("IdxServer"+cOpz)
  (Alias())->(dbgotop())
  For i := 1 To 10
     aadd(a2,strzero((Alias())->Srv)+'-'+(Alias())->Title)
     (Alias())->(dbskip())
  Next
  (Alias())->(dbgotop())
  *
  FV3_OpenModal('Select for Upload')
  FV3_SetValue('LIST2' ,a1[1])
  FV3_SetValue('LIST1',a2[1])
  FV3_SetValue('TEXT1','select the server where you want to upload the file  (Server '+cOpz+')')
  FV3_SetValue('TEXT2','select the file you want to upload  (Folder Upload)')
  *
  FV3_FramedText3('TEXT1',600,1,CLR_YELLOW,'Arial',10,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ListBox('LIST1',600,200,a2)
  FV3_SkipRow(10)
  FV3_FramedText3('TEXT2',600,1,CLR_YELLOW,'Arial',10,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ListBox('LIST2',600,200,a1)
  *
  FV3_Show(2)
  *
  IF FV3_Result()
     (Alias())->(dbgoto(FV3_GetValue('LIST1')))
     If (Alias())->(RLock())
        Replace (Alias())->Title  with a1[FV3_GetValue('LIST2')]
        nRet := FV3_GetValue('LIST1')
        (Alias())->(__dbUnlock())
     Endif
  Endif
  *
Return nRet
*
Procedure Exit_App(cWinMain)
  *
  SendToLog(__CODETURNOFFSERVER__)
  *
Return
*
Procedure Run_Chat(cWinMain)
  *
  If File('HMG_XChat.Exe')
     execute file 'HMG_XChat.Exe'
  Endif
  *
Return
*
Procedure FillLstBox1(cWinMain)
  Local i
  Local j
  Local aRay     := {}
  Local a1       := {'A','B','C'}
  *
  FV3_DoMethod('LSTBOX1','DeleteAllItems')
  FV3_DoMethod('LSTBOX1','Refresh')
  *
  For j := 1 To Len(a1)
     dbselectarea("IdxServer"+a1[j])
     ('IdxServer'+a1[j])->(dbgotop())
     For i := 1 To 10
        If !Empty(('IdxServer'+a1[j])->Title) .and.  !('IdxServer'+a1[j])->Flag1
           FV3_DoMethod('LSTBOX1','AddItem',Padr(a1[j]+ntrim(i),3,' ')+'-'+('IdxServer'+a1[j])->Title)
        Endif
        *
        ('IdxServer'+a1[j])->(dbskip())
     Next
  Next
  FV3_DoMethod('LSTBOX1','Refresh')
  *
Return
*
Procedure SetLstBox1(cWinMain)
  Local nSel
  Local nPos
  *
  nSel := GetProperty(cWinMain,'RGROUP2','Value')
  If nSel == 2
     MsgInfo('Select Stop download!'+CRLF+'Append others files and Select Start Download')
     Return
  Endif
  *
  nPos := FV3_GetProperty('LSTBOX1','Value')
  FV3_DoMethod('LSTBOX2','AddItem',FV3_GetProperty('LSTBOX1','Item',nPos))
  FV3_DoMethod('LSTBOX2','Refresh')
  *
  aadd(aListFiles,FV3_GetProperty('LSTBOX1','Item',nPos))
  *
Return
*
Procedure SetLstBox2(cWinMain)
  Local nSel,nPos
  *
  nSel := GetProperty(cWinMain,'RGROUP2','Value')
  If nSel == 2
     MsgInfo('Select Stop download!'+CRLF+'Append others files and Select Start Download')
     Return
  Endif
  *
  nPos := FV3_GetProperty('LSTBOX2','Value')
  FV3_DoMethod('LSTBOX2','DeleteItem',nPos)
  FV3_DoMethod('LSTBOX2','Refresh')
  *
  nPos := ascan(aListFiles,{|_a| Left(_a,3) == Left(FV3_DoMethod('LSTBOX2','Item',nPos),3) })
  If nPos > 0
     aListFiles := hb_ADel(aListFiles,nPos,.T.)
  Endif
  *
Return
*
Procedure RGROUP1_OnChange(cWinMain,c1)
  *msginfo(c1)
Return
*
Procedure RGROUP2_OnChange(cWinMain,c1)
  Local nSel := GetProperty(cWinMain,c1,'Value')
  *
  If nSel == 2
     StartDownload(cWinMain)
  Endif
  *
Return
*
Procedure Download(cSrv,cTitle)
  Local c3
  Local c4
  Local c5
  Local nHandle
  Local nHandle2
  Local nTop
  Local t0
  Local t1
  Local i
  Local j
  Local k
  Local cBuff
  Local nBytes
  Local n3
  Local x1,x2,x3
  Local a1     := {'25%','50%','75%','100%'}
  Local lAbort
  *
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_YELLOW)
  FV3_SetProperty('TEXT1','Value','..........data downloading..........')
  FV3_SetProperty('TEXT3','Value','')
  *
  FV3_SetProperty('TEXT3','Value',cTitle)
  *
  dbselectarea("Server"+cSrv)
  dbgotop()
  *
  lAbort := .F.
  lStop  := .F.
  If File('DOWNLOAD\'+cTitle)
     *
     SendToLog('('+cSrv+') - '+Time()+' - Resume file '+cTitle)
     nTop := ("Server"+cSrv)->(LastRec())
     ("Server"+cSrv)->(dbgobottom())
     c3   := ntrim(("Server"+cSrv)->Bytes)
     ("Server"+cSrv)->(dbgotop())
     *
     nHandle := FOpen('DOWNLOAD\'+cTitle)
     *
     PBar1(0,nTop)
     PBar1(0)
     *
     t1 := 0
     nBytes := 5700*8
     k := Int(FileSize(nHandle)/nBytes)
     cBuff  := space(nBytes)
     nHandle2 := Fcreate('DOWNLOAD\_'+cTitle)
     FSeek(nHandle,0)
     For j := 1 To k
        t1 += nBytes
        PBar1(j)
        FV3_SetProperty('TEXT1','Value','Data downloading   ('+ntrim(t1)+'/'+c3+')')
        Fread(nHandle,@cBuff,nBytes)
        Fwrite(nHandle2,cBuff)
        If lStop
           lStop := .F.
           If MsgYesNo('Abort Operation?')
              lAbort := .T.
              exit
           endif
        Endif
     Next
     *
     If !lAbort
        *
        SendToLog('('+cSrv+') - '+Time()+' - Download file '+cTitle)
        ++k
        For j := k To nTop
           ("Server"+cSrv)->(dbgoto(j))
           t1 += nBytes
           PBar1(j)
           FV3_SetProperty('TEXT1','Value','Data downloading   ('+ntrim(t1)+'/'+c3+')')
           FWrite(nHandle2,hb_base64Decode(Trim(('Server'+cSrv)->Note)))
           *
           If lStop
              lStop := .F.
              If MsgYesNo('Abort Operation?')
                 lAbort := .T.
                 exit
              endif
           Endif
           *
        Next
     Endif
     Fclose(nHandle2)
     Fclose(nHandle)
     FV3_SetProperty('TEXT1','Value','--------------Wait------------')
     PBar1(0)
     If !lAbort
        Ferase('DOWNLOAD\'+cTitle)
        Frename('DOWNLOAD\_'+cTitle,'DOWNLOAD\'+cTitle)
     endif
     *
  Else
     *
     nTop := ("Server"+cSrv)->(LastRec())
     ("Server"+cSrv)->(dbgobottom())
     ("Server"+cSrv)->(dbSkip(-1))
     *
     PBar1(0,nTop)
     PBar1(0)
     t1 := 0
     *
     nBytes := 5700*8
     nHandle := FCreate('DOWNLOAD\'+cTitle)
     *
     x2 := int(nTop/2)
     x1 := int(x2/2)
     x3 := x2+x1
     n3 := 0
     *
     For j := 1 To nTop
        ("Server"+cSrv)->(dbgoto(j))
        *
        IF j == x1 .or. j == x2 .or. j == x3
           SendToLog('('+cSrv+') - '+Time()+' ('+a1[++n3]+')'+'-Download '+Trim(cTitle))
        Endif
        *
        PBar1(j)
        t1 += nBytes
        FV3_SetProperty('TEXT1','Value','Data downloading   ('+ntrim(t1)+')')
        FWrite(nHandle,hb_base64Decode(Trim(('Server'+cSrv)->Note)))
        *
        If lStop
           lStop := .F.
           If MsgYesNo('Abort Operation?')
              lAbort := .T.
              exit
           endif
        Endif
        *
     Next
     Fclose(nHandle)
     PBar1(0)
  Endif
  *
  FV3_SetProperty('TEXT3','Value','')
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
  FV3_SetProperty('TEXT1','Value','..........CLIENT DISCONNECT..........')
  *
Return
*
Procedure Get_ListFiles()
  Local cRet := ''
  *
  If Len(aListFiles) > 0
     cRet := aListFiles[1]
     aListFiles := hb_ADel(aListFiles,1,.T.)
  Endif
  *
Return cRet
*
Procedure StartDownload(cWinMain)
  Local nBox1
  Local c1
  Local cSrv
  Local cTitle
  Local i
  Local nPos
  *
  If lDownload
     lDownload := .F.
     FV3_EnableButton(_PAUSE_)
     DisableAll()
     Do while .T.
        *
        If len(aListFiles) == 0
           exit
        else
           c1     := aListFiles[1]
           cSrv   := Trim(Left(c1,3))
           cTitle := Trim(Substr(c1,5))
        Endif
        *
        SendToLog('----------Begin Download------------')
        SendToLog('('+cSrv+') - '+Time()+' - Download '+cTitle)
        Download(cSrv,cTitle)
        SendToLog('----------Download Completed!------------')
        *
        FV3_DoMethod('LSTBOX2','DeleteItem',1)
        FV3_DoMethod('LSTBOX2','Refresh')
        *
        aListFiles := hb_ADel(aListFiles,1,.T.)
        *
        If len(aListFiles) == 0
           exit
        endif
        *
     Enddo
     *
     FV3_SetProperty('RGROUP2','Value',1)
     FV3_DisableButton(_PAUSE_)
     EnableAll()
     *
     lDownload := .T.
     *
     nBox1 := FV3_GetProperty('RGROUP1','Value')
     *
     If nBox1 == 1
        execute file 'DOWNLOAD'
     elseIf nBox1 == 2
        FV3_EndWindow()
     elseif nBox1 == 3
        Exit_App(cWinMain)
        FV3_EndWindow()
     endif
     *
  Endif
  *
Return
*
Procedure SendToLog(cMess)
  Local nArea := Select()
  *
  dbselectArea('Log')
  Log->(dbAppend())
  Replace Log->Msg with cLocalHost+'->'+cUser+'-'+cMess
  *
  Log->(dbAppend())
  Replace Log->Msg with [$NULL$]
  *
  Select(nArea)
  *           .
Return
*
