// **************************************
// author Brunello Pulix
// Cagliari (Italy)
// brunellopulix@gmail.com
// placed in the public domain
// **************************************
//
*
# include "Hmg.ch"
# include "HmgP2PServer.ch"
*
# include "Fileio.prg"
# include "Tools.prg"
*
#translate NTRIM( <v1> ) => Ltrim(str(<v1>))
*
Request DbfCdx
*
Procedure Main()
  *
  Set BrowseSync On
  Set Date British
  *
  If !File('CFG.INI')
     Ini_Open('CFG.INI')
     Ini_Put("Setup","IP"       ,'127.0.0.1'    )
     Ini_Put("Setup","Host"     ,'LocalHost'    )
     Ini_Put("Setup","User"     ,'Administrator')
     Ini_Put("Setup","LocalHost",'Administrator')
     Ini_Close()
  Endif
  *
  RDDSETDEFAULT('DBFCDX')
  *
  Install()
  *
  Private pListenSocket
  Private cIP
  Private cHost
  Private cUser
  Private lStop
  Private lTimer
  Private cLocalHost
  *
  Ini_Open('CFG.INI')
  cIP        := Ini_Get("Setup","IP"  )
  cHost      := Ini_Get("Setup","Host")
  cUser      := Ini_Get("Setup","User")
  cLocalHost := Ini_Get("Setup","LocalHost")
  Ini_Close()
  *
  lStop  := .F.
  lTimer := .F.
  *
  FV3_OpenMain([HMGP2PServer with Netio - - by Brunello Pulix (Italy)],nil,{|cWinMain| PostInit(cWinMain) },{|| DbCloseAll() })
  FV3_SetValue('TEXT1'    ,'..........SERVER DISCONNECT..........')
  FV3_SetValue('TEXT2'    ,'' )
  FV3_SetValue('TEXT3'    ,'' )
  FV3_SetValue('TEXT4'    ,'Host: '+cHost+'    Address: '+cIP)
  FV3_SetValue('CHECK1'   ,.F.)
  FV3_SetValue('LBOX1'    ,'')
  *
  FV3_FramedText3('TEXT4',700,1,CLR_BROWN,'Arial',13,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ProgressBar('PBar1',698,20)
  FV3_SkipRow(20)
  FV3_FramedText3('TEXT1',700,1,CLR_RED,'Arial',13,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_FramedText3('TEXT3',700,1,CLR_WHITE,'Arial',9,,.T.,.T.,.T.,.F.,.F.)
  *
  FV3_SkipRow(30)
  *
  FV3_Button(_CONNECT_      , 117,30,{|cWinMain| Connect(cWinMain)         },.T.)
  FV3_Button(_UPLOAD_A_     , 116,30,{|cWinMain| UploadA(cWinMain)         },.T.)
  FV3_Button(_INDEX_A_      , 116,30,{|| Mask1('A')                },.T.)
  FV3_Button(_INDEX_B_      , 116,30,{|| Mask1('B')                },.T.)
  FV3_Button(_INDEX_C_      , 117,30,{|| Mask1('C')                },.T.)
  FV3_ButtonCancel('Close'  , 117,60)
  FV3_SkipRow(30)
  FV3_Button(_DISCONNECT_   , 117,30,{|cWinMain| DisConnect(cWinMain)      },.F.)
  FV3_Button(_ZIP_CLIENT_   , 116,30,{|| Zipclient('HMGP2PCLIENT') },.T.)
  FV3_Button(_PAUSE_        , 116,30,{|| lStop := .T.              },.F.)
  FV3_Button(_IP_           , 116,30,{|cWinMain| Mask2(cWinMain)           },.T.)
  FV3_Button(_FOLDER_UPLOAD_, 116,30,{|| OpenFolder()              },.T.)
  *
  FV3_SkipRow(30)
  FV3_ListBox('LBOX1',700,250,{''},.F.,nil,nil,nil)
  *
  FV3_SkipRow(20)
  FV3_CheckBox('CHECK1',300,'Accepts shutdown from client')
  *
  FV3_SetFont('LBOX1','Courier New',10)
  *
  FV3_Show(0)
  *
Return
*
Procedure PostInit(cWinMain)
  *
  Use "DB\Log"  New
  zap
  Close
  *
  Use "DB\Log"  Shared New
  *
Return
*
Procedure Connect(cWinMain)
  Local cTime
  *
  pListenSocket := netio_mtserver(2941,cIP)
  if empty( pListenSocket )
     Msginfo("Errore di connessione al Sever!")
  else
     FV3_DisableButton(_CONNECT_    )
     FV3_DisableButton('Close'      )
     FV3_DisableButton(_UPLOAD_A_   )
     FV3_DisableButton(_INDEX_A_    )
     FV3_DisableButton(_INDEX_B_    )
     FV3_DisableButton(_INDEX_C_    )
     FV3_DisableButton(_IP_         )
     FV3_DisableButton(_ZIP_CLIENT_ )
     *
     FV3_EnableButton(_DISCONNECT_)
     *
     FV3_SetProperty('TEXT1'  ,'BackColor',CLR_MAGENTA)
     FV3_SetProperty('TEXT1','Value','..........SERVER CONNECT..........')
     *
  ENDIF
  cTime   := Time()
  dbselectarea('Log')
  Log->(dbappend())
  Replace Log->Msg with cUser+'-'+Dtoc(Date())+' - '+cTime+' - Server is on Line'
  *
  Log->(dbappend())
  Replace Log->Msg with [$NULL$]
  *
  If !lTimer
     DEFINE TIMER Timer1 OF &(cWinMain) INTERVAL 800 ACTION UpdateMsg(cWinMain)
     lTimer := .T.
  else
     SetProperty(cWinMain,'Timer1','Enabled',.T.)
  endif
  *
Return
*
Procedure DisConnect(cWinMain)
  Local cString,cTime
  *
  cTime   := Time()
  *
  dbselectarea('Log')
  Log->(dbappend())
  Replace Log->Msg with cUser+'-'+Dtoc(Date())+' - '+cTime+' - Server is off'
  hb_idleSleep(0.300)
  *
  SetProperty(cWinMain,'Timer1','Enabled',.F.)
  *
  DoMethod(cWinMain,'LBOX1','AddItem',cUser+'-'+Dtoc(Date())+' - '+cTime+' - Server is off')
  DoMethod(cWinMain,'LBOX1','SetFocus')
  FV3_SetProperty('LBOX1','Value',GetProperty(cWinMain,'LBOX1','ItemCount'))
  DoMethod(cWinMain,'LBOX1','Refresh')
  *
  cString := hb_MemoRead('LOG\LOG.TXT')
  For i := 1 To GetProperty(cWinMain,'LBOX1','ItemCount')
     cString += GetProperty(cWinMain,'LBOX1','Item',i)+CRLF
  Next
  hb_MemoWrit('LOG\LOG.TXT',cString)
  *
  FV3_DisableButton(_DISCONNECT_)
  *
  FV3_EnableButton(_CONNECT_    )
  FV3_EnableButton('Close'      )
  FV3_EnableButton(_UPLOAD_A_   )
  FV3_EnableButton(_INDEX_A_    )
  FV3_EnableButton(_INDEX_B_    )
  FV3_EnableButton(_INDEX_C_    )
  FV3_EnableButton(_IP_         )
  FV3_EnableButton(_ZIP_CLIENT_ )
  *
  netio_serverstop( pListenSocket )
  pListenSocket := nil
  *
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
  FV3_SetProperty('TEXT1','Value','.........SERVER DISCONNECT..........')
  *
Return
*
Procedure Install()
  Local i
  Local aDbf
  *
  MakeDir([DB])
  MakeDir([UPLOAD])
  MakeDir([LOCAL])
  MakeDir([LOG])
  *
  IF !File('LOG\LOG.TXT')
     hb_MemoWrit('LOG\LOG.TXT','')
  Endif
  *
  IF !File('DB\IP.DBF')
     aDbf := {;
     {'HOST'     ,'C', 30,  0},;
     {'ADDRESS'  ,'C', 15,  0},;
     {'LOCALHOST','C', 15,  0}}
     DBCREATE('DB\IP.DBF',aDbf,'DBFCDX')
     *
     Use 'DB\IP' New
     For i := 1 To 10
        dbappend()
        Replace HOST    with 'LocalHost'
        Replace ADDRESS with '127.0.0.1'
     Next
     close
  ENDIF
  *
  IF !File('DB\Server.DBF')
     aDbf := {;
     {'PROG' ,'C', 60,  0},;
     {'NOTE' ,'M', 10,  0},;
     {'PASS' ,'C', 30,  0},;
     {'FLAG1','L',  1,  0}}
     DBCREATE('DB\Server.DBF',aDbf,'DBFCDX')
  ENDIF
  *
  IF !File('DB\IdxServerA.DBF')
     aDbf := {;
     {'SRV'  ,'N',  2,  0},;
     {'USER' ,'C', 30,  0},;
     {'TITLE','C',100,  0},;
     {'PASS' ,'C', 30,  0},;
     {'FLAG1','L',  1,  0}}
     DBCREATE('DB\IdxServerA.DBF',aDbf,'DBFCDX')
     *
     Use 'DB\IdxServerA' New
     For i := 1 To 10
        dbappend()
        Replace Srv  with i
        Replace User with 'Owner'
     Next
     close
  ENDIF
  *
  IF !File('DB\IdxServerB.DBF')
     aDbf := {;
     {'SRV'  ,'N',  2,  0},;
     {'USER' ,'C', 30,  0},;
     {'TITLE','C',100,  0},;
     {'PASS' ,'C', 30,  0},;
     {'FLAG1','L',  1,  0}}
     DBCREATE('DB\IdxServerB.DBF',aDbf,'DBFCDX')
     *
     Use 'DB\IdxServerB' New
     For i := 1 To 10
        dbappend()
        Replace Srv  with i
        Replace User with 'Brunello'
        Replace Pass with 'admin'
     Next
     close
  ENDIF
  *
  IF !File('DB\IdxServerC.DBF')
     aDbf := {;
     {'SRV'  ,'N',  2,  0},;
     {'USER' ,'C', 30,  0},;
     {'TITLE','C',100,  0},;
     {'PASS' ,'C', 30,  0},;
     {'FLAG1','L',  1,  0}}
     DBCREATE('DB\IdxServerC.DBF',aDbf,'DBFCDX')
     *
     Use 'DB\IdxServerC' New
     For i := 1 To 10
        dbappend()
        Replace Srv  with i
        Replace User with 'Brunello'
        Replace Pass with 'admin'
     Next
     close
  ENDIF
  *
  For i := 1 To 10
     IF !File('DB\ServerA'+Ntrim(i)+'.DBF')
        aDbf := {;
        {'TITLE','C', 60,  0},;
        {'NOTE' ,'M', 10,  0},;
        {'FLAG1','L',  1,  0},;
        {'BYTES','N', 12,  0}}
        DBCREATE('DB\ServerA'+Ntrim(i)+'.DBF',aDbf,'DBFCDX')
     ENDIF
  Next
  *
  For i := 1 To 10
     IF !File('DB\ServerB'+Ntrim(i)+'.DBF')
        aDbf := {;
        {'TITLE','C', 60,  0},;
        {'NOTE' ,'M', 10,  0},;
        {'FLAG1','L',  1,  0},;
        {'BYTES','N', 12,  0}}
        DBCREATE('DB\ServerB'+Ntrim(i)+'.DBF',aDbf,'DBFCDX')
     ENDIF
  Next
  For i := 1 To 10
     IF !File('DB\ServerC'+Ntrim(i)+'.DBF')
        aDbf := {;
        {'TITLE' ,'C', 60,  0},;
        {'NOTE'  ,'M', 10,  0},;
        {'FLAG1' ,'L',  1,  0},;
        {'BYTES' ,'N', 12,  0}}
        DBCREATE('DB\ServerC'+Ntrim(i)+'.DBF',aDbf,'DBFCDX')
     ENDIF
  Next
  *
  IF !File('DB\LOG.DBF')
     aDbf := {{'MSG' ,'C',512, 0}}
     DBCREATE('DB\LOG.DBF',aDbf,'DBFCDX')
  ENDIF
  *
Return
*
Procedure UploadA(cWinMain)
  Local n1
  Local n2
  Local cString
  Local nBytes
  Local nBytes2
  Local nHandle
  Local c1
  Local c2
  Local nTotBytes
  Local aTemp
  Local lAbort := .F.
  Local cBuff
  *
  n1 := MyFormA()
  *
  If n1 == 0
     Return
  Endif
  *
  FV3_DisableButton(_UPLOAD_A_   )
  FV3_DisableButton(_CONNECT_    )
  FV3_DisableButton(_INDEX_A_    )
  FV3_DisableButton(_INDEX_B_    )
  FV3_DisableButton(_INDEX_C_    )
  FV3_DisableButton(_IP_         )
  FV3_DisableButton(_ZIP_CLIENT_ )
  FV3_DisableButton('Close'      )
  *
  c2 := Ntrim(n1)
  *
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_YELLOW)
  *
  Use 'DB\IdxServerA'  New
  (Alias())->(dbgoto(n1))
  c1 := Trim((Alias())->Title)
  close
  *
  Use 'DB\ServerA'+c2  New
  (Alias())->(__dbzap())
  (alias())->(dbgotop())
  *
  FV3_SetProperty('TEXT1','Value','..........Data conversion and uploading..........')
  FV3_SetProperty('TEXT3','Value',c1)
  **********************************************************************
  FV3_EnableButton('Pause')
  lStop := .F.
  *
  nBytes    := 5700*8
  cString   := ''
  nHandle   := Fopen('UPLOAD\'+c1)
  cBuff     := space(nBytes)
  nTotBytes := FileSize(nHandle)
  FIleTop(nHandle)
  *
  PBar1(0,(nTotBytes/nBytes))
  PBar1(0)
  *
  #Ifdef ___FV3_HMG___
  SETPROGRESSBARMARQUEE(GetControlHandle('PBAR1',cWinMain), .T.,6000)
  #endif
  *
  n2      := 0
  nBytes2 := 0
  *
  Do While (Alias())->(!Feof(nHandle))
     *
     PBar1(++n2)
     FV3_SetProperty('TEXT1','Value','Data conversion and uploading   ('+Ntrim(nTotBytes)+')')
     *
     Fread(nHandle,@cBuff,nBytes)
     nBytes2 += nBytes
     (alias())->(dbappend())
     Replace (alias())->Title with c1
     Replace (alias())->Note with hb_Base64Encode(cBuff,76)
     Replace (alias())->Bytes with nBytes2
     nTotBytes -= nBytes
     If nTotBytes < nBytes
        nBytes := nTotBytes
        cBuff  := space(nBytes)
     Endif
     *
     If lStop
        lStop := .F.
        If MsgYesNo('Abort Operation?')
           (Alias())->(__dbzap())
           lAbort := .T.
           exit
        endif
     Endif
     *
  Enddo
  FV3_SetProperty('TEXT1','Value','--------------Wait------------')
  FClose(nHandle)
  close
  *************************************
  #Ifdef ___FV3_HMG___
  SETPROGRESSBARMARQUEE(GetControlHandle('PBAR1',cWinMain), .F., 0)
  #endif
  *
  FV3_DisableButton('Pause')
  *
  FV3_SetProperty('TEXT1'  ,'BackColor',CLR_RED)
  FV3_SetProperty('TEXT1','Value','..........SERVER DISCONNECT..........')
  FV3_SetProperty('TEXT3','Value','')
  *
  If lAbort
     MsgInfo('Aborted operation!')
  else
     MsgInfo('Successful operation!')
  Endif
  *
  FV3_EnableButton(_UPLOAD_A_   )
  FV3_EnableButton(_CONNECT_    )
  FV3_EnableButton('Close'      )
  FV3_EnableButton(_ZIP_CLIENT_ )
  FV3_EnableButton(_INDEX_A_    )
  FV3_EnableButton(_INDEX_B_    )
  FV3_EnableButton(_INDEX_C_    )
  FV3_EnableButton(_IP_         )
  PBar1(0)
  *
Return
*
Static Procedure MyFormA()
  Local  a1    := {}
  Local  a2    := {}
  Local  a3    := {}
  Local aTemp  := {}
  Local nRet   := 0
  Local i
  *
  aTemp := Directory('UPLOAD\*.*','A')
  If Empty(aTemp)
     Return 0
  Endif
  *
  For i := 1 To Len(aTemp)
     aadd(a1,aTemp[i,1])
  Next
  *
  If empty(a1)
     Return 0
  Endif
  *
  Use 'DB\IdxServerA'  New
  (Alias())->(dbgotop())
  For i := 1 To 10
     aadd(a2,strzero((Alias())->Srv)+'-'+(Alias())->Title)
     (Alias())->(dbskip())
  Next
  (Alias())->(dbgotop())
  *
  FV3_OpenModal('Select for Upload')
  FV3_SetValue('LIST2' ,a1[1])
  FV3_SetValue('LIST1',a2[1])
  FV3_SetValue('TEXT1','select the server where you want to upload the file  (Server A)')
  FV3_SetValue('TEXT2','select the file you want to upload  (Folder Upload)')
  *
  FV3_FramedText3('TEXT1',600,1,CLR_YELLOW,'Arial',10,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ListBox('LIST1',600,200,a2)
  FV3_SkipRow(10)
  FV3_FramedText3('TEXT2',600,1,CLR_YELLOW,'Arial',10,,.T.,.T.,.T.,.F.,.F.)
  FV3_SkipRow(20)
  FV3_ListBox('LIST2',600,200,a1)
  *
  FV3_Show(2)
  *
  IF FV3_Result()
     (Alias())->(dbgoto(FV3_GetValue('LIST1')))
     Replace (Alias())->Title  with a1[FV3_GetValue('LIST2')]
     nRet := FV3_GetValue('LIST1')
  Endif
  close
  *
Return nRet
*
Procedure Mask1(cOpz)
  Local aTemp := {}
  Local nChoice
  *
  Use 'DB\IdxServer'+cOpz  New
  (alias())->(dbgotop())
  *
  FV3_OpenModal('Index Server ('+cOpz+')')
  *
  FV3_Browse('BROWSE1',830,300       ,;
  {80,200,400,100}                   ,;
  {'Srv','User','Title','Download'}  ,;
  Alias()                           ,;
  {'Srv','User','Title','If((Alias())->Flag1,"OFF","ON")'},;
  {|| Mask1Property(cOpz) },nil  ,;
  {0,0,0})
  *
  FV3_SkipRow(-20)
  *
  FV3_Show(1)
  *
  If FV3_Result()
     *
  Endif
  close
  *
Return
*
Procedure Mask1Property(cOpz)
  Local c1,cAlias
  *
  FV3_OpenModal('Property Server ('+cOpz+')')
  FV3_SetValue('USER' ,(Alias())->User)
  FV3_SetValue('PASSW',(Alias())->Pass)
  FV3_SetValue('CHECK1',.F.)
  FV3_SetValue('CHECK2',(Alias())->Flag1)
  *
  FV3_Label('User',100)
  FV3_TextBox("USER",200,'',0)
  FV3_SkipRow(30)
  *
  FV3_Label('Password',100)
  FV3_TextBox("PASSW",200,'',0)
  *
  FV3_SkipRow(30)
  FV3_Label('',100)
  FV3_CheckBox('CHECK2',200,'Disable Download')
  *
  FV3_SkipRow(30)
  FV3_Label('',100)
  FV3_CheckBox('CHECK1',200,'zap server '+Ntrim((alias())->Srv))
  *
  FV3_Show(2)
  *
  If FV3_Result()
     *
     Replace (Alias())->User  with FV3_GetValue('USER')
     Replace (Alias())->Flag1 with FV3_GetValue('CHECK2')
     Replace (Alias())->Pass  with Trim(FV3_GetValue('PASSW'))
     Replace (Alias())->Flag1 with FV3_GetValue('CHECK2')
     cAlias := Alias()
     FV3_SetProperty('BROWSE1','Value',(cAlias)->(Recno()))
     FV3_DoMethod('BROWSE1','Refresh')
     *
     If FV3_GetValue('CHECK1')
        If MsgYesNo('Sure?')
           Replace (Alias())->Title with ''
           c1 := Ntrim((cAlias)->Srv)
           Use "DB\Server"+cOpz+c1  New
           zap
           close
           dbSelectarea(cAlias)
        Endif
        FV3_SetProperty('BROWSE1','Value',(cAlias)->(Recno()))
        FV3_DoMethod('BROWSE1','Refresh')
        *
     Endif
     *
  Endif
  *
Return
*
Procedure Mask2(cWinMain)
  Local aTemp := {}
  Local nChoice
  *
  Use "DB\IP"  New
  (alias())->(dbgotop())
  *
  FV3_OpenModal('Network Information')
  *
  FV3_Browse('BROWSE2',400,300       ,;
  {180,180}                          ,;
  {'Host','Address'}              ,;
  (Alias())                       ,;
  {'(Alias())->Host','(Alias())->Address'}      ,;
  {|| Mask2Property(cWinMain) },nil  ,;
  {0,0})
  *
  FV3_SkipRow(-20)
  *
  FV3_Show(1)
  *
  If FV3_Result()
     *
  Endif
  close
  *
Return
*
Procedure Mask2Property(cWinMain)
  *
  FV3_OpenModal('Network Property')
  FV3_SetValue('HOST'   ,(Alias())->Host)
  FV3_SetValue('ADDRESS',(Alias())->Address)
  FV3_SetValue('CHECK1' ,.F.)
  *
  FV3_Label('Host',100)
  FV3_TextBox("Host",200,'',0)
  FV3_SkipRow(30)
  *
  FV3_Label('Address',100)
  FV3_TextBox("ADDRESS",200,'',0)
  *
  FV3_SkipRow(30)
  FV3_Label('',100)
  FV3_CheckBox('CHECK1',200,'Set Default')
  *
  FV3_Show(2)
  *
  If FV3_Result()
     *
     Replace (Alias())->Host    with FV3_GetValue('HOST')
     Replace (Alias())->Address with FV3_GetValue('ADDRESS')
     FV3_SetProperty('BROWSE2','Value',(Alias())->(Recno()))
     FV3_DoMethod('BROWSE2','Refresh')
     *
     If FV3_GetValue('CHECK1')
        cHost := Trim((Alias())->Host)
        cIP   := Trim((Alias())->Address)
        Ini_Open('CFG.Ini')
        Ini_Put("Setup","Host",cHost)
        Ini_Put("Setup","IP"  ,cIP)
        Ini_Close()
        SetProperty(cWinMain,'TEXT4','Value','Host: '+cHost+'    Address: '+cIP)
     Endif
     *
  Endif
  *
Return
*
Static Procedure Zipclient(cCode)
  Local aZip   := {cCode+'.EXE'}
  Local c1
  *
  If !File('HMGP2PCLIENT\HMGP2PCLIENT.EXE')
     MsgBox('HMGP2PCLIENT\HMGP2PCLIENT.EXE'+' not Found!')
     Return
  Endif
  *
  FV3_DisableButton(_ZIP_CLIENT_)
  *
  Ferase('LOCAL\'+cCode+'.ZIP')
  __CopyFile('HMGP2PCLIENT\HMGP2PCLIENT.EXE','HMGP2PCLIENT.EXE')
  *
  #ifdef ___FV3_HMG___
  COMPRESSFILES('LOCAL\'+cCode+'.ZIP' , aZip , nil , .F. )
  #else
  COMPRESS aZip TO 'LOCAL\'+cCode+'.ZIP' BLOCK nil OVERWRITE
  #endif
  *
  Ferase('HMGP2PCLIENT.EXE')
  *
  If File('LOCAL\'+cCode+'.ZIP')
     *
     c1 := UnoGet('Password For Update',space(25),'password?','!!!!!!!!!!!!!!!!!!!!!!!!!',300,0)
     Use "DB\Server" New
     (Alias())->(dbgotop())
     (Alias())->(__dbLocate({|| Trim(Server->Prog) == cCode+'.ZIP' }))
     If (Alias())->(!Found())
        (Alias())->(dbappend())
     endif
     Replace (Alias())->Prog with cCode+'.ZIP'
     Replace (Alias())->Note with hb_Base64Encode(hb_MemoRead('LOCAL\'+cCode+'.ZIP'),70)
     Replace (Alias())->Pass with Trim(c1)
     close
     *
     MsgInfo('successful operation!'+CRLF+'Run Client and Select Update Client!')
  else
     MsgInfo('operation failed!')
  Endif
  *
  FV3_EnableButton(_ZIP_CLIENT_)
  PBar1(0)
  *
Return
*
Procedure OpenFolder()
  *
  execute file 'UPLOAD'
  *
Return
*
Procedure UpdateMsg(cWinMain)
  Local i
  Local cString
  Local a1    := {}
  Local lExit := .F.
  *
  Log->(dbgoTop())
  do while Log->(!Eof())
     *
     If !Empty(Log->Msg)
        IF __CODETURNOFFSERVER__ $ Log->Msg
           aadd(a1,Time()+' - Close Server')
           lExit := .T.
           exit
        Else
           do While (Log->(!RLock()))
           Enddo
           IF [$NULL$] $ Log->Msg
              *
           else
              aadd(a1,Trim(Log->Msg))
           Endif
           Log->(dbunlock())
        endif
     Endif
     *
     Log->(dbskip())
     *
  enddo
  *
  If !Empty(a1)
     *
     FV3_DoMethod('LBOX1','DeleteAllItems')
     For i := 1 To Len(a1)
        FV3_DoMethod('LBOX1','AddItem',a1[i])
     Next
     *
     FV3_DoMethod('LBOX1','SetFocus')
     FV3_SetProperty('LBOX1','Value',GetProperty(cWinMain,'LBOX1','ItemCount'))
     FV3_DoMethod('LBOX1','Refresh')
     *
     a1 := {}
     *
     If lExit
        If !FV3_GetProperty('CHECK1','Value')
           lExit := .F.
        Endif
     Endif
     *
  Endif
  *
  IF lExit
     Disconnect(cWinMain)
     FV3_EndWindow()
  Endif
  *
Return
*
