// **************************************
// author Brunello Pulix
// Cagliari (Italy)
// brunellopulix@gmail.com
// placed in the public domain
// **************************************
//
*
# include "hmg.ch"
# include "common.ch"
*
Static aIni
Static cIniFile
Static lChanged
*
Function Ini_Put(cSection,cParam,xValue)
  Local i,c1
  Local nLen := Len(cParam+'=')
  *
  lChanged := .T.
  *
  xValue := HB_ValtoStr(xValue)
  *
  i := ascan(aIni,{|_a| _a[1]== '['+cSection+']' .and. Left(_a[2],nLen) == cParam+'=' })
  If i > 0
     c1 := Left(aIni[i,2],AT('=',aIni[i,2]))
     aIni[i,2] := c1+xValue
  else
     aadd(aIni,{'['+cSection+']',cParam+'='+xValue})
  Endif
  *
Return
*
Function Ini_Get(cSection,cParam,cOpz)
  Local xRet := ''
  Local i
  Local nLen := Len(cParam+'=')
  *
  hb_Default(@cOpz,'C')
  *
  i := ascan(aIni,{|_a| _a[1]== '['+cSection+']' .and. Left(_a[2],nLen) == cParam+'=' })
  If i > 0
     xRet := Substr(aIni[i,2],AT('=',aIni[i,2])+1)
     *
     if valtype(cOpz) == 'B'
        xRet := eval(xRet,cOpz)
     elseIf cOpz == 'N'
        xRet := Val(xRet)
     elseIf cOpz == 'D'
        xRet := cTod(xRet)
     Endif
     *
  Endif
  *
Return xRet
*
Procedure Ini_Open(cIni)
  Local oFile,cLine,cId
  *
  aIni := {}
  cId  := ''
  cIniFile := cIni
  lChanged := .F.
  *
  oFile := TFileRead():New(cIniFile)
  oFile:Open()
  DO WHILE oFile:MoreToRead()
     cLine := oFile:ReadLine()
     If !Empty(cLine)
        If Left(cLine,1) == '['
           cId := cLine
        else
           aadd(aIni,{cId,cLine})
        Endif
     Endif
  ENDDO
  oFile:Close()
  *
  If empty(aIni)
     aadd(aIni,{'',''})
  Endif
  *
Return
*
Procedure Ini_Close()
  *
  if lChanged
     Ini_Save()
  endif
  *
  aIni     := {}
  cIniFile := ''
  *
Return
*
Static Procedure Ini_Save()
  Local i,nHandle,cSection
  *
  asort(aIni,,,{|x,y| x[1] < y[1] })
  *
  nHandle := Fcreate(cIniFile,0)
  cSection := aIni[1,1]
  Fwrite(nHandle,cSection+CRLF)
  For i := 1 To len(aIni)
     If aIni[i,1] == cSection
        Fwrite(nHandle,aIni[i,2]+CRLF)
     else
        Fwrite(nHandle,CRLF)
        cSection := aIni[i,1]
        Fwrite(nHandle,cSection+CRLF)
        Fwrite(nHandle,aIni[i,2]+CRLF)
     Endif
  Next
  FClose(nHandle)
  *
Return
*
